# Config Grub/WarX-16 - main.cfg
# Copyright (C) 2018 WarX-16 <contact@warx-16.org>.
# https://www.warx-16.org
#
# Config Grub/WarX-16 is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Config Grub/WarX-16 is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Config Grub/WarX-16.  If not, see <https://www.gnu.org/licenses/>.
#
# Certain part of Config Grub/WarX-16 was inspired by Super Grub Disk
# ( Adrian Gibanel Lopez - Jordan Uggla - https://www.supergrubdisk.org/ )


############## VARIABLE ################################################

set checkpoint="${G_PATH}/osdetect/main.cfg"

set default=0


############## MENU ####################################################

menuentry --class=rescan $"Rescan devices"" ?" {
unset ls_dev; unset all_boot
configfile "${G_PATH}/osdetect/select.cfg"
}
espace

for device in (*); do
	if ! regexp '\((.*),(.*)\)' "${device}"; then		# filtre les partitions, garde que les périphériques
		regexp -s dev '\((.*)\)' "${device}"			# $dev: parenthesis removed from $device
		source "${G_PATH}/osdetect/icondev.cfg"		# choose menuentry icon according to device

		for part_string in ${ls_dev}; do
			if regexp "^\(${dev}(.*)\)" "${part_string}"; then

				if [ -z "${ls_part}" ]; then
					set ls_part="${part_string}"
				else
					set ls_part="${ls_part} ${part_string}"
				fi

				if regexp -s os_find ':3:(.*):4:' "${part_string}"; then

					if regexp ';;' "${os_find}"; then
						tr -s os_find ';;' '  ' "${os_find}"
					#~ else
						#~ set os_find="${os_string}"
					fi
					for os in ${os_find}; do
						if [ -z "${ls_os}" ]; then
							set ls_os="${os}"
						else
							if ! regexp "${os}" "${ls_os}"; then
								set ls_os="${ls_os} ${os}"
							fi
						fi
					done; unset os; unset os_find

				fi
			fi
		done; unset part_string

		if [ -n "${ls_os}" ]; then

			for boot_string in ${all_boot}; do
				if regexp "^\(${dev}(.*)\)" "${boot_string}"; then
					if [ -z "${ls_boot}" ]; then
						set ls_boot="${boot_string}"
					else
						set ls_boot="${ls_boot} ${boot_string}"
					fi
				fi
			done; unset boot_string

			submenu --class="${dev_ico}" "(${dev}) [${ls_os}]" "${ls_part}" "${ls_boot}" "${dev_ico}" {
			retour "${checkpoint}"
			set ls_part="$2"
			set ls_boot="$3"
			set dev_ico="$4"

			for part_string in ${ls_part}; do
				regexp -s partition '^(.*):0:' "${part_string}"
				regexp -s part '\((.*)\)' "${partition}"
				regexp -s tscheme ':0:(.*):1:' "${part_string}"
				regexp -s fstype ':1:(.*):2:' "${part_string}"
				regexp -s uuid ':2:(.*):3:' "${part_string}"
				if regexp ':3:(.*):4:' "${part_string}"; then
					for boot_string in ${ls_boot}; do
						if regexp "(^| )\(${part}\):0:" "${boot_string}"; then
							regexp -s os_entry ':0:(.*):1:' "${boot_string}"
							regexp -s os_find ':1:(.*):2:' "${boot_string}"
							regexp -s ls_item ':2:(.*):3:' "${boot_string}"

							source "${G_PATH}/osdetect/iconos.cfg"
							source "${G_PATH}/osdetect/${os_entry}entry.cfg"

						fi
					done; unset boot_string
				else

					menuentry --class="${dev_ico}-noos" "(${part}:${tscheme}:${fstype}) ["$"no bootable file known""]" "${part}" "${tscheme}" "${fstype}" "${uuid}" {
					set part="$2"
					set tscheme="$3"
					set fstype="$4"
					set uuid="$5"

					set_pag
					clear

					echo ''
					echo $"partition schema"" : ${tscheme}"
					echo $"device"" : ${part}"
					echo $"file system"" : ${fstype}"
					echo "uuid"" : ${uuid}"

					menu_continue
					reset_pag

					configfile "${checkpoint}"
					}

				fi
			done; unset part_string
			}

			unset ls_part; unset ls_boot; unset ls_os

		elif [ -n "${ls_part}" ]; then

			submenu --class="${dev_ico}-noos" "(${dev}) ["$"no bootable file known""]" "${ls_part}" "${dev_ico}" {
			retour "${checkpoint}"
			set ls_part="$2"
			set dev_ico="$3"

			for part_string in ${ls_part}; do
				regexp -s partition '^(.*):0:' "${part_string}"
				regexp -s part '\((.*)\)' "${partition}"
				regexp -s tscheme ':0:(.*):1:' "${part_string}"
				regexp -s fstype ':1:(.*):2:' "${part_string}"
				regexp -s uuid ':2:(.*):3:' "${part_string}"

				menuentry --class="${dev_ico}-noos" "(${part}:${tscheme}:${fstype}) ["$"no bootable file known""]" "${part}" "${tscheme}" "${fstype}" "${uuid}" {
				set part="$2"
				set tscheme="$3"
				set fstype="$4"
				set uuid="$5"

				set_pag
				clear

				echo ''
				echo $"partition schema"" : ${tscheme}"
				echo $"device"" : ${part}"
				echo $"file system"" : ${fstype}"
				echo "uuid"" : ${uuid}"

				menu_continue
				reset_pag

				configfile "${checkpoint}"
				}

			done; unset part_string
			}

			unset ls_part

		else

			menuentry --class="${dev_ico}-noos" "(${dev}:${tscheme}:${fstype}) ["$"no partition known""]" "${dev}" "${tscheme}" "${fstype}" "${uuid}" {
			set dev="$2"
			set tscheme="$3"
			set fstype="$4"
			set uuid="$5"

			set_pag
			clear

			echo ''
			echo $"device"" : ${dev}"
			echo $"file system"" : ${fstype}"
			echo "uuid"" : ${uuid}"

			menu_continue
			reset_pag

			configfile "${checkpoint}"
			}

		fi
		unset dev; unset tscheme; unset fstype; unset uuid; unset dev_ico

	fi
done; unset device

source "${PATH_MENU}/footer.cfg"

snd_warn

